
#ifndef ScatterWeb.Process
#define ScatterWeb.Process

#include <ScatterWeb.System.h>
#include <ScatterWeb.CC1020.h>
#include <string.h>
#include <stdio.h>

// globals
#define REQUEST 99
#define DATA 98
#define REPLY 97

// *** Structures ***

/**
 * Route
 */
struct route {
	// Destination
	uint16_t target;
	// Source
	uint16_t source;
	// Initiator
	uint16_t id;
	// Route
	uint16_t header[8];
} route;

/**
 * Data
 */
struct data {
	// Payload
	uint16_t* data;
	// Route
	uint16_t header[8];
} data;

// Functions

/**
 * Retry Sending Route Packet
 */
void reroute();

/**
 * Route Reply Packet
 */
void send_reply(struct netpacket_handler_args* args);

/**
 * Send Route Request
 * target: Destination
 * change 	(1): change packet, send afterwards
 * 			(0): create packet
 */
void send_request(uint16_t target, uint16_t change);

/**
 * Data Packet
 * create	(1): create packet
 * 			( ): change
 */
void send_data(struct netpacket_handler_args* args_copy, uint16_t flag);

#endif
